#!/usr/bin/env python
# -*- coding: utf-8 -*-


"""
 * ------------------------------------------------------------------------
 * bmTraces
 * ------------------------------------------------------------------------
 * @license : GNU Affero General Public License Version 3 <http://www.gnu.org/licenses>
 * @author  : Pascal SALAUN 
 * @Website : http://www.bm-stats.org <http://www.bm-stats.org>
 * ------------------------------------------------------------------------
"""

import sqlite3
import os
import sys

class sqlQuery:

        def __init__(self, db):
                self.conn = sqlite3.connect(db)
                self.c = self.conn.cursor()


	def close(self):
		self.c.close()
                del self.c
                self.conn.close()
                
		
        def selectUser(self,tupl):
                self.c.execute("""SELECT * FROM account WHERE account=?""",tupl) 
                res = self.c.fetchone()
                return res
	
	def initUserDb(self):
		self.c.execute("""
		DROP TABLE IF EXISTS logs""")
		
		self.c.execute("""
		CREATE TABLE `logs` (
			`id`	INTEGER NOT NULL PRIMARY KEY AUTOINCREMENT,
			`dat`	TEXT NOT NULL,
			`hour`	TEXT NOT NULL,
			`messageid`	TEXT NOT NULL,
			`cas`	TEXT NOT NULL,
			`data`	TEXT NOT NULL,
			`status`	TEXT
		);
		""")
		
		self.c.execute("vacuum")
		
		self.conn.commit()

        def insertIntoLog(self, tupl):
		query = "insert into `logs` (dat,hour,messageid,cas,data,status) values (?,?,?,?,?,?) ;"
		try: 
			self.c.executemany(query, tupl)  
			self.conn.commit()
		except sqlite3.ProgrammingError:
			pass
	
	
	def getCountEntry(self):
		self.c.execute("""SELECT count(*) from logs;""")
		res = self.c.fetchall()
		return res[0]
	
	
	def getMessageList(self, tupl):
		
		# Because messageid has its own column
		if 'messageid' in tupl:
			newtupl = (tupl[1],)
			self.c.execute("""SELECT dat,hour,messageid, messageid as data FROM logs where cas='server' and messageid like ? order by id asc;""", newtupl)
		else:
			self.c.execute("""SELECT dat,hour,messageid,data FROM logs where cas=? and data like ? order by id asc;""", tupl)
		
		res = self.c.fetchall()
                return res
	

	def getMessageDetails(self, tupl):
		self.c.execute("""SELECT * FROM logs where messageid=? order by id asc;""", tupl)
		res = self.c.fetchall()
                return res